// overcalc.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "xlcall.h"
#include "framewrk.h"
#include <stdexcept>
#include <sstream>
#include <string>

static LPSTR rgFuncs[][3] = {
	{" calccount", " RR", " calccount"},
	{" calccountp", " RP", " calccountp"},
	0
};

extern "C" __declspec(dllexport) int xlAutoOpen(void)
{
	OutputDebugStringA("xlAutoOpen");

	static XLOPER xDLL;	

	Excel4(xlGetName, &xDLL, 0, NULL);

    for (int i=0;rgFuncs[i][0];i++) 
	{
		Excel4(xlfRegister, 0, 4,
				(LPXLOPER)&xDLL,
				(LPXLOPER)TempStr(rgFuncs[i][0]),
				(LPXLOPER)TempStr(rgFuncs[i][1]),
				(LPXLOPER)TempStr(rgFuncs[i][2]));
	}

	/* Free the XLL filename */
	Excel4(xlFree, 0, 1, (LPXLOPER)&xDLL);

	FreeAllTempMemory();
	return 1;
}

LPXLOPER calccount_inner(XLOPER & xlo, LPXLOPER px)
{
	// this is exceptionally naughty.  Never do it. :P
	// (also note we're using it for both real addin methods).
	static int uncalced_calls = 0; 

	try
	{
		switch (px->xltype)
		{
		case xltypeMulti:
			// abuse xltypeMulti a little here, as we're not actually after the 
			// content.
		case xltypeRef:
		case xltypeSRef:
			{
				XLOPER xMulti;
				if (xlretSuccess != Excel(xlCoerce, &xMulti, 2,
					px, TempInt(xltypeMulti))) {
						std::stringstream ss;
						uncalced_calls++;
					return 0;
				}
				// discard input - we don't care.
				Excel(xlFree, NULL, 0, &xMulti);
				xlo.xltype = xltypeNum;
				xlo.val.num = static_cast<double>(uncalced_calls);
				uncalced_calls = 0;
			}
			break;
		default:
			throw std::runtime_error("Expecting xltypeRef/xltypeSRef");
		}
	}
	catch (std::runtime_error & e)
	{
		OutputDebugStringA(e.what());
		xlo.xltype = xltypeErr;
		xlo.val.err = xlerrValue;
	}

	return &xlo;	
}

extern "C" LPXLOPER __declspec(dllexport) calccount(LPXLOPER px)
{
	static XLOPER xlo;
	return calccount_inner(xlo, px);
}

extern "C" LPXLOPER __declspec(dllexport) calccountp(LPXLOPER px)
{
	static XLOPER xlo;
	return calccount_inner(xlo, px);
}

extern "C" __declspec(dllexport) int WINAPIV xlAutoClose(void)
{
	// unregister, unless lazy, which I am.
	return 1;
}
